<?php
/*
 * inc.Clanwars.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */


class clanwars_admin
{
 var $db,$smarty,$prefix;  //database class, smarty class, prefix in tables
 var $show;  //show x clanwars per page
 var $flags_dir;  //directory with flags
 var $tpl_dir;
 
 var $tbl_players;

 function init()
 {
   switch(get_param('action')) {
     case 'recalculate':  $this->recalculate();  break;
     case 'players':      $this->players();      break;
     default:             $this->clanwars();     break;
   }
 } //end func
 
 function players()
 {
   switch(get_param('mod')) {
     case 'add':     $this->players_add();     break;
     case 'edit':    $this->players_edit();    break;
     case 'delete':  $this->players_delete();  break;
     default:        $this->players_list();    break;
   }
 } //end func
 
 function clanwars()
 {
   switch(get_param('mod')) {
     case 'add':     $this->clanwars_add();     break;
     case 'edit':    $this->clanwars_edit();    break;
     case 'delete':  $this->clanwars_delete();  break;
     default:        $this->clanwars_list();    break;
   }
 } //end func

 function clanwars_add()
 {
   switch(get_param('step')) {
     case '2':  $this->clanwars_add_step2(get_param('cwid'), post_param('games1v1'), post_param('games2v2'), post_param('games3v3'), post_param('games4v4'));  break;
     default:   $this->clanwars_add_step1();  break;
   }
 } //end func
 
 function players_list()
 {
   $this->db->query("select pid,nick,status from ".$this->prefix."clanwars_players order by status desc,nick");
   $tbl_players = array();
   while($this->db->next_record()) {
     $tbl_players[] = $this->db->Record;
   }
   
   $this->smarty->assign_by_ref('tbl_players', $tbl_players);
   $this->smarty->display($this->tpl_dir.'players_list.tpl');
   
 } //end func
 
 function players_add()
 {
   if(post_param('submit_players_add') && $this->players_add_execute()) return 0;

   $this->smarty->display($this->tpl_dir.'players_add.tpl');
   
 } //end func
 
 function players_add_execute()
 {
   $post['nick'] = trim(post_param('nick'));
   $post['status']      = (int) post_param('status');
   $post['description'] =  trim(post_param('description'));

   #-- if any errors
   if(!$post['nick']) return 0;
   
   #-- if double record
   $this->db->query("select * from ".$this->prefix."clanwars_players where nick='{$post['nick']}'");
   if($this->db->num_rows() != 0) return 0;
   
   #-- insert player
   $this->db->query("insert into ".$this->prefix."clanwars_players set nick='{$post['nick']}', status='{$post['status']}', description='{$post['description']}'");

   $this->players_list();
   return 1;
   
 } //end func
 
 function players_edit()
 {
   $pid = (int) get_param('pid');

   if(post_param('submit_players_edit') && $this->players_edit_execute()) return 0;
   
   $this->db->query("select * from ".$this->prefix."clanwars_players where pid='$pid'");
   $this->db->next_record();

   $this->smarty->assign('nick', $this->db->Record['nick']);
   $this->smarty->assign('status', $this->db->Record['status']);
   $this->smarty->assign('description', $this->db->Record['description']);

   $this->smarty->display($this->tpl_dir.'players_edit.tpl');
 } //end func
 
 function players_edit_execute()
 {
   $pid = (int) get_param('pid');
   
   $post['nick'] = trim(post_param('nick'));
   $post['status']      = (int) post_param('status');
   $post['description'] =  trim(post_param('description'));

   #-- if any errors
   if(!$post['nick']) return 0;

   #-- update player
   $this->db->query("update ".$this->prefix."clanwars_players set nick='{$post['nick']}', status='{$post['status']}', description='{$post['description']}' where pid='$pid'");

   $this->players_list();
   return 1;
 } //end func
 
 function players_delete()
 {
   $pid = (int) get_param('pid');
   
   $this->db->query("delete from ".$this->prefix."clanwars_players where pid='$pid'");
   
   $this->players_list();
   
 } //end func

 function clanwars_list()
 {
   $this->db->query("select * from ".$this->prefix."clanwars order by cwid desc limit {$this->show}");
   $tbl_clanwars = array();
   while($this->db->next_record()) {
     $tbl_clanwars[] = $this->db->Record;
   }
   
   $this->smarty->assign_by_ref('tbl_clanwars', $tbl_clanwars);
   $this->smarty->display($this->tpl_dir.'clanwars_list.tpl');
   
 } //end func
 
 function clanwars_add_step1()
 {
   if(post_param('submit_clanwars_add') && $this->clanwars_add_step1_execute()) return 0;

   $this->get_flags();
   $this->smarty->display($this->tpl_dir.'clanwars_add_step1.tpl');
   
 } //end func
 
 function clanwars_add_step1_execute()
 {
   $post = array('title', 'enemy', 'flag', 'time', 'games1v1', 'games2v2', 'games3v3', 'games4v4');
   foreach($post as $key=>$value) {
     $post[$value] = post_param($value);
   }

   $post['title'] = trim($post['title']);
   $post['enemy'] = trim($post['enemy']);
   $post['time']  = strtotime("{$post['time']['Year']}-{$post['time']['Month']}-{$post['time']['Day']}");
   $post['games1v1'] = (int) $post['games1v1'];
   $post['games2v2'] = (int) $post['games2v2'];
   $post['games3v3'] = (int) $post['games3v3'];
   $post['games4v4'] = (int) $post['games4v4'];

   #-- if any errors
   if(!$post['title'] || !$post['enemy']) return 0;
   
   #-- double record
   $this->db->query("select * from ".$this->prefix."clanwars where time='{$post['time']}' and title='{$post['title']}' and enemy='{$post['enemy']}' and flag='{$post['flag']}'");
   $num = $this->db->num_rows();
   if($num == 1) {
     $this->db->next_record();
     $cwid = $this->db->Record['cwid'];
     $this->clanwars_add_step2($cwid, $post['games1v1'], $post['games2v2'], $post['games3v3'], $post['games4v4']);
     return 1;
   }
   elseif($num != 0) return 0;

   #-- inserting record
   $this->db->query("insert into ".$this->prefix."clanwars set title='{$post['title']}', enemy='{$post['enemy']}', flag='{$post['flag']}', time='{$post['time']}'");
   
   if(!$this->db->Query_ID) return 0;
   
   $this->db->query("select LAST_INSERT_ID() as cwid");
   $this->db->next_record();
   $cwid = $this->db->Record['cwid'];
   
   $this->clanwars_add_step2($cwid, $post['games1v1'], $post['games2v2'], $post['games3v3'], $post['games4v4']);
   
   # return true - dont include form step1
   return 1;
   
 } //end func
 
 function clanwars_add_step2($cwid, $games1v1, $games2v2, $games3v3, $games4v4)
 {
   if(post_param('submit_clanwars_add_step2') && $this->clanwars_add_step2_execute()) return 0;

   $this->get_players();

   if (!isset($_POST['games1v1']) || !is_array($_POST['games1v1'])) $_POST['games1v1'] = array();
   if (!isset($_POST['games2v2']) || !is_array($_POST['games2v2'])) $_POST['games2v2'] = array();
   if (!isset($_POST['games3v3']) || !is_array($_POST['games3v3'])) $_POST['games3v3'] = array();
   if (!isset($_POST['games4v4']) || !is_array($_POST['games4v4'])) $_POST['games4v4'] = array();
   
   if(is_array($games1v1)) $games1v1 = count($games1v1);
   else $games1v1 = (int) $games1v1;

   if(is_array($games2v2)) $games2v2 = count($games2v2);
   else $games2v2 = (int) $games2v2;

   if(is_array($games3v3)) $games3v3 = count($games3v3);
   else $games3v3 = (int) $games3v3;

   if(is_array($games4v4)) $games4v4 = count($games4v4);
   else $games4v4 = (int) $games4v4;
   
   if($games1v1) $games1v1 = range(0, $games1v1-1); else $games1v1 = array();
   if($games2v2) $games2v2 = range(0, $games2v2-1); else $games2v2 = array();
   if($games3v3) $games3v3 = range(0, $games3v3-1); else $games3v3 = array();
   if($games4v4) $games4v4 = range(0, $games4v4-1); else $games4v4 = array();

   $this->smarty->assign('cwid', $cwid);
   $this->smarty->assign('games1v1', $games1v1);
   $this->smarty->assign('games2v2', $games2v2);
   $this->smarty->assign('games3v3', $games3v3);
   $this->smarty->assign('games4v4', $games4v4);
   
   $this->smarty->display($this->tpl_dir.'clanwars_add_step2.tpl');

 } //end func
 
 function clanwars_add_step2_execute()
 {
   $cwid = (int) get_param('cwid');
   
   #-- if clanwar with that id exists
   $this->db->query("select * from ".$this->prefix."clanwars where cwid='$cwid'");
   if($this->db->num_rows() != 1) return 0;
   $this->db->next_record();

   $this->get_players();

   #-- form variables
   $games1v1 = (array) post_param('games1v1');
   $games2v2 = (array) post_param('games2v2');
   $games3v3 = (array) post_param('games3v3');
   $games4v4 = (array) post_param('games4v4');
   
   #-- if form fields arent properly filled
   if(!$this->games_correct($games1v1, '1v1')) return 0;
   if(!$this->games_correct($games2v2, '2v2')) return 0;
   if(!$this->games_correct($games3v3, '3v3')) return 0;
   if(!$this->games_correct($games4v4, '4v4')) return 0;
   
   #-- inserting into database records
   #-- updating players statistics

   $this->games_add($games1v1, '1v1', $cwid);
   $this->games_add($games2v2, '2v2', $cwid);
   $this->games_add($games3v3, '3v3', $cwid);
   $this->games_add($games4v4, '4v4', $cwid);
   
   $this->clanwars_list();

   return 1;
   
 } //end func
 
 function games_add(&$games, $type, $cwid)
 {
   foreach($games as $key=>$value)
   {
     $value['cwid'] = $cwid;
     $value['type'] = $type;
     $this->get_nicks($value);

     #-- if double record - break this iteration of foreach
     if($this->query_game_select($value) != 0) continue;

     #-- insert game
     $this->query_game_insert($value);
     #-- update player
     $this->switch_type_update_player($value, '+');
   }
   
 } //end func
 
 function get_nicks(&$val)
 {
   switch($val['type'])
   {
     case '4v4':  $val['p4'] = addslashes($this->tbl_players[$val['pid4']]);
     case '3v3':  $val['p3'] = addslashes($this->tbl_players[$val['pid3']]);
     case '2v2':  $val['p2'] = addslashes($this->tbl_players[$val['pid2']]);
     case '1v1':  $val['p1'] = addslashes($this->tbl_players[$val['pid1']]);
   }
 } //end func

 function games_correct(&$games, $type)
 {
   foreach($games as $key=>$value)
   {
     switch($type)
     {
       case '4v4':  if(!$value['pid4'] || !$value['ep4']) return 0;
       case '3v3':  if(!$value['pid3'] || !$value['ep3']) return 0;
       case '2v2':  if(!$value['pid2'] || !$value['ep2']) return 0;
       case '1v1':  if(!$value['pid1'] || !$value['ep1']) return 0;
     }
     if(!is_numeric($value['pts1']) || !is_numeric($value['epts1'])) return 0;
   }
   return 1;
   
 } //end func
 
 function query_game_select($value)
 {
   $this->db->query($this->query_game($value, 'select'));
   return $this->db->num_rows();
 }
 
 function query_game_insert($value)
 {
   $this->db->query($this->query_game($value, 'insert'));
 } //end func
 
 function query_game_update($value)
 {
   $this->db->query($this->query_game($value, 'update'));
 } //end func
 
 function query_game($value, $mysql)
 {
   $query = '';
   
   switch($mysql) {
     case 'select':  $query .= "select * from";  break;
     case 'insert':  $query .= "insert into";    break;
     case 'update':  $query .= "update";         break;
   }
   $query .= " ".$this->prefix."clanwars_games";
   switch($mysql) {
     case 'select':  $query .= " where";  break;
     case 'insert':  $query .= " set";    break;
     case 'update':  $query .= " set";    break;
   }
   switch($mysql) {
     case 'select':  $join = "and";  break;
     case 'insert':  $join = ",";    break;
     case 'update':  $join = ",";    break;
   }
   switch($mysql) {
     case 'select':
     case 'insert':  $query .= " cwid='{$value['cwid']}' {$join} type='{$value['type']}' {$join}";  break;
     case 'update':  break;
   }
   $query .= " pts1='{$value['pts1']}' {$join} epts1='{$value['epts1']}'";

   $tmp = array();

   switch($value['type']) {
     case '4v4':  $tmp[4] = " {$join} p4='{$value['p4']}' {$join} pid4='{$value['pid4']}' {$join} ep4='{$value['ep4']}'";
     case '3v3':  $tmp[3] = " {$join} p3='{$value['p3']}' {$join} pid3='{$value['pid3']}' {$join} ep3='{$value['ep3']}'";
     case '2v2':  $tmp[2] = " {$join} p2='{$value['p2']}' {$join} pid2='{$value['pid2']}' {$join} ep2='{$value['ep2']}'";
     case '1v1':  $tmp[1] = " {$join} p1='{$value['p1']}' {$join} pid1='{$value['pid1']}' {$join} ep1='{$value['ep1']}'";
   }

   ksort($tmp);
   foreach($tmp as $value2) $query .= $value2;
   
   switch($mysql) {
     case 'update':  $query .= " where gid='{$value['gid']}'";  break;
   }
   
   return $query;
 }
 
 function clanwars_edit()
 {
   if(post_param('submit_clanwars_edit') && $this->clanwars_edit_execute()) return 0;
   if(get_param('action') == 'delete') $this->clanwars_edit_game_delete();
   
   $cwid = (int) get_param('cwid');

   #-- select clanwars data
   $this->db->query("select * from ".$this->prefix."clanwars where cwid='$cwid'");
   $this->db->next_record();

   $this->smarty->assign('title', $this->db->Record['title']);
   $this->smarty->assign('enemy', $this->db->Record['enemy']);
   $this->smarty->assign('flag',  $this->db->Record['flag']);
   $this->smarty->assign('time',  $this->db->Record['time']);
   
   $this->get_players();
   $this->get_flags();
   
   #-- select clanwars_games data
   $this->db->query("select * from ".$this->prefix."clanwars_games where cwid='$cwid' order by gid");
   $games1v1 = array();
   $games2v2 = array();
   $games3v3 = array();
   $games4v4 = array();
   while($this->db->next_record())
   {
     switch($this->db->Record['type'])
     {
       case '1v1':  $games1v1[] = $this->db->Record;  break;
       case '2v2':  $games2v2[] = $this->db->Record;  break;
       case '3v3':  $games3v3[] = $this->db->Record;  break;
       case '4v4':  $games4v4[] = $this->db->Record;  break;
     }
   }
   
   $this->smarty->assign_by_ref('games1v1', $games1v1);
   $this->smarty->assign_by_ref('games2v2', $games2v2);
   $this->smarty->assign_by_ref('games3v3', $games3v3);
   $this->smarty->assign_by_ref('games4v4', $games4v4);
   
   $this->smarty->display($this->tpl_dir.'clanwars_edit.tpl');
   
 } //end func
 
 function clanwars_edit_game_delete()
 {
   $gid = (int) get_param('gid');
   
   #-- select game for updating stats
   $this->db->query("select * from ".$this->prefix."clanwars_games where gid='$gid'");
   if($this->db->num_rows() != 1) return 0;

   $this->db->next_record();
   $value = $this->db->Record;
   
   $this->switch_type_update_player($value, '-');
   
   #-- delete game
   $this->db->query("delete from ".$this->prefix."clanwars_games where gid='$gid'");
   
 } //end func
 
 function clanwars_edit_execute()
 {
   $cwid = (int) get_param('cwid');

   #-- if clanwar exists
   $this->db->query("select * from ".$this->prefix."clanwars where cwid='$cwid'");
   if($this->db->num_rows() != 1) return 0;
   $this->db->next_record();

   $post = array('title', 'enemy', 'flag', 'time');
   foreach($post as $key=>$value) {
     $post[$value] = post_param($value);
   }

   $post['title'] = trim($post['title']);
   $post['enemy'] = trim($post['enemy']);
   //flag
   $post['time']  = strtotime("{$post['time']['Year']}-{$post['time']['Month']}-{$post['time']['Day']}");
   
   #-- if any errors
   if(!$post['title'] || !$post['enemy']) return 0;
   
   #-- form variables
   $games1v1 = (array) post_param('games1v1');
   $games2v2 = (array) post_param('games2v2');
   $games3v3 = (array) post_param('games3v3');
   $games4v4 = (array) post_param('games4v4');
   
   #-- now checking if all fields are filled
   if(!$this->games_correct($games1v1, '1v1')) return 0;
   if(!$this->games_correct($games2v2, '2v2')) return 0;
   if(!$this->games_correct($games3v3, '3v3')) return 0;
   if(!$this->games_correct($games4v4, '4v4')) return 0;
   
   #-- updating clanwars info
   $this->db->query("update ".$this->prefix."clanwars set title='{$post['title']}', enemy='{$post['enemy']}', flag='{$post['flag']}', time='{$post['time']}' where cwid='$cwid'");
   
   $this->get_players();
   
   #-- compare games , if different - update games and players stats
   $this->games_update($games1v1, '1v1');
   $this->games_update($games2v2, '2v2');
   $this->games_update($games3v3, '3v3');
   $this->games_update($games4v4, '4v4');
   
   $this->clanwars_list();
   
   return 1;
   
 } //end func
 
 function games_update(&$games, $type)
 {
   foreach($games as $key=>$val)
   {
     $val['type'] = $type;

     $this->db->query("select * from ".$this->prefix."clanwars_games where gid='{$val['gid']}'");
     if($this->db->num_rows() != 1) continue;

     $this->db->next_record();
     $rec = $this->db->Record;

     if($this->games_different($rec, $val))
     {
       $this->get_nicks($val);
       $this->query_game_update($val);
       $this->switch_type_update_player($rec, '-');
       $this->switch_type_update_player($val, '+');
     }
   }
   
 } //end func
 
 function games_different($val1, $val2)
 {
   if($val1['type'] != $val2['type'] ||
      $val1['pts1'] != $val2['pts1'] ||
      $val1['epts1'] != $val2['epts1']
     ) return 1;

   switch($val1['type']) {
     case '4v4':  if($val1['pid4'] != $val2['pid4'] || $val1['ep4'] != $val2['ep4']) return 1;
     case '3v3':  if($val1['pid3'] != $val2['pid3'] || $val1['ep3'] != $val2['ep3']) return 1;
     case '2v2':  if($val1['pid2'] != $val2['pid2'] || $val1['ep2'] != $val2['ep2']) return 1;
     case '1v1':  if($val1['pid1'] != $val2['pid1'] || $val1['ep1'] != $val2['ep1']) return 1;
   }
     
   return 0;
 } //end func
 
 function clanwars_delete()
 {
   $cwid = (int) get_param('cwid');

   #-- select * games and delete these games from players stats - update players
   $this->db->query("select type,pts1,epts1,pid1,pid2,pid3,pid4 from ".$this->prefix."clanwars_games where cwid='$cwid'");
   $games = array();
   while($this->db->next_record()) {
     $games[] = $this->db->Record;
   }

   foreach($games as $key=>$value)
   {
     $this->switch_type_update_player($value, '-');
   }
   
   #-- delete games
   $this->db->query("delete from ".$this->prefix."clanwars_games where cwid='$cwid'");
   
   #-- delete clan war
   $this->db->query("delete from ".$this->prefix."clanwars where cwid='$cwid'");
   
   $this->clanwars_list();
   
 } //end func
 
 function recalculate()
 {
   #-- select all players
   $this->db->query("select pid from ".$this->prefix."clanwars_players order by pid");
   $players = array();
   while($this->db->next_record()) {
     $pid = $this->db->Record['pid'];
     $players[$pid]['games']   = 0;
     $players[$pid]['win1v1']  = 0;
     $players[$pid]['win2v2']  = 0;
     $players[$pid]['win3v3']  = 0;
     $players[$pid]['win4v4']  = 0;
     $players[$pid]['loss1v1'] = 0;
     $players[$pid]['loss2v2'] = 0;
     $players[$pid]['loss3v3'] = 0;
     $players[$pid]['loss4v4'] = 0;
   }
   
   #-- query all games , updating players statistics in $players array
   $this->db->query("select type,pts1,epts1,pid1,pid2,pid3,pid4 from ".$this->prefix."clanwars_games order by gid;");
   while($this->db->next_record())
   {
     $val = $this->db->Record;

     $win  = 0;
     $loss = 0;

     if($val['pts1'] > $val['epts1'])     $win++;
     elseif($val['pts1'] < $val['epts1']) $loss++;
     
     switch($val['type'])
     {
       case '4v4':
         if(isset($players[$val['pid4']]))
         {
           $players[$val['pid4']]['win'.$val['type']]  += $win;
           $players[$val['pid4']]['loss'.$val['type']] += $loss;
         }
       case '3v3':
         if(isset($players[$val['pid3']]))
         {
           $players[$val['pid3']]['win'.$val['type']]  += $win;
           $players[$val['pid3']]['loss'.$val['type']] += $loss;
         }
       case '2v2':
         if(isset($players[$val['pid2']]))
         {
           $players[$val['pid2']]['win'.$val['type']]  += $win;
           $players[$val['pid2']]['loss'.$val['type']] += $loss;
         }
       case '1v1':
         if(isset($players[$val['pid1']]))
         {
           $players[$val['pid1']]['win'.$val['type']]  += $win;
           $players[$val['pid1']]['loss'.$val['type']] += $loss;
         }
     }
     
     if(isset($players[$val['pid1']])) $players[$val['pid1']]['games']++;
     if(isset($players[$val['pid2']])) $players[$val['pid2']]['games']++;
     if(isset($players[$val['pid3']])) $players[$val['pid3']]['games']++;
     if(isset($players[$val['pid4']])) $players[$val['pid4']]['games']++;
   }

   #-- updating players statistics
   foreach($players as $key=>$val)
   {
     $this->db->query("update ".$this->prefix."clanwars_players set games='{$val['games']}', win1v1='{$val['win1v1']}', win2v2='{$val['win2v2']}', win3v3='{$val['win3v3']}', win4v4='{$val['win4v4']}', loss1v1='{$val['loss1v1']}', loss2v2='{$val['loss2v2']}', loss3v3='{$val['loss3v3']}', loss4v4='{$val['loss4v4']}' where pid='$key'");
   }
   
   $this->clanwars_list();

 } //end func
 
 function switch_type_update_player($value, $sign='+')
 //array(pid1, pid2, pid3, pid4, type, pts1, epts1)
 {
   switch($value['type'])
   {
     case '4v4':  $this->update_player($value['pid4'], $value['type'], $value['pts1'], $value['epts1'], $sign);
     case '3v3':  $this->update_player($value['pid3'], $value['type'], $value['pts1'], $value['epts1'], $sign);
     case '2v2':  $this->update_player($value['pid2'], $value['type'], $value['pts1'], $value['epts1'], $sign);
     case '1v1':  $this->update_player($value['pid1'], $value['type'], $value['pts1'], $value['epts1'], $sign);
   }
 } //end func

 function update_player($pid, $type, $pts1, $epts1, $sign='+')
 //updating player
 //if sign = '+' (default) adding game , updating player stats
 //if sign = '-' removing game , updating player stats
 {
   $win  = 0;
   $loss = 0;

   if($pts1 > $epts1)     $win++;
   elseif($pts1 < $epts1) $loss++;

   $query = "update ".$this->prefix."clanwars_players set games=games{$sign}1";
   if($win)  $query .= ", win{$type}=win{$type}{$sign}{$win}";
   if($loss) $query .= ", loss{$type}=loss{$type}{$sign}{$loss}";
   $query .= " where pid='$pid'";

   $this->db->query($query);

 } //end func

 function get_players()
 {
   $this->db->query("select pid,nick from ".$this->prefix."clanwars_players where status='1' order by nick");
   $this->tbl_players = array();
   while($this->db->next_record()) {
     $this->tbl_players[$this->db->Record['pid']] = $this->db->Record['nick'];
   }

   $this->smarty->assign_by_ref('tbl_players', $this->tbl_players);

 } //end func

 function get_flags()
 {
   $dir = ReadDirectory($this->flags_dir);
   $tbl_flags = array();
   foreach($dir as $key=>$value) {
     $tbl_flags[$value] = substr($value, 0, -4);
   }
   natsort($tbl_flags);
   $this->smarty->assign_by_ref('tbl_flags', $tbl_flags);

 } //end func

}

?>
