<?php
/*
 * modules/news/inc.NewsAdmin.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */

class _news {
 var $db;
 var $smarty;
 
 var $nid;
 var $mod;
 
 var $tbl_news = array();
 var $error = array();

 function _news($db,$smarty)
 {
   include 'init/lib/html.lib.php';
   include 'init/lib/time.lib.php';

   $this->db = &$db;
   $this->smarty = &$smarty;
   
   $this->mod = get_param('mod');
   $this->nid = (int) get_param('nid');
   
   #-- choices
   if($this->mod == 'delete' && $this->nid) $this->news_delete();
   elseif($this->mod == 'edit' && $this->nid && post_param('submit_news_edit')) $this->news_edit();
   elseif($this->mod == 'edit' && $this->nid) $this->get_news_edit();
   elseif($this->mod == 'add' && post_param('submit_news_add')) $this->news_add();

   if(!$this->mod) $this->get_list();
   
   #-- smarty variables
   $this->smarty->assign_by_ref('tbl_news', $this->tbl_news);
   
   #-- display
   if($this->mod == 'edit') $this->smarty->display('admin/_news/news_edit.tpl');
   elseif($this->mod == 'add') $this->smarty->display('admin/_news/news_add.tpl');
   else $this->smarty->display('admin/_news/list.tpl');

 } //end func
 
 function get_list()
 {
   $this->db->query("select * from ".prefix."news order by nid desc limit {$GLOBALS['cfg']['news_admin']}");
   while($this->db->next_record()) {
     $this->tbl_news[] = $this->db->Record;
   }
 } //end func
 
 function get_news_edit()
 {
   $this->db->query("select * from ".prefix."news where nid='{$this->nid}'");
   $this->db->next_record();
   $this->tbl_news['title'] = check_undo($this->db->Record['title']);
   $this->tbl_news['text'] = check_undo($this->db->Record['text']);
 } //end func
 
 function news_edit()
 {
   $post_title = check_html(post_param('title'));
   $post_text  = check_nosafe(post_param('text'));

   if(!$post_title) $this->error['title'] = 1;
   if(!$post_text) $this->error['text'] = 1;
   
   if($this->error) return 0;
   
   $this->db->query("update ".prefix."news set title='$post_title', text='$post_text' where nid='{$this->nid}'");
   $this->mod = '';

 } //end func
 
 function news_delete()
 {
   $this->db->query("delete from ".prefix."news where nid='{$this->nid}'");
   $this->db->query("delete from ".prefix."news_posts where nid='{$this->nid}'");
   $this->mod = '';
 } //end func
 
 function news_add()
 {
   $post_title = check_html(post_param('title'));
   $post_text  = check_nosafe(post_param('text'));

   if(!$post_title) $this->error['title'] = 1;
   if(!$post_text) $this->error['text'] = 1;

   if($this->error) return 0;
   
   $ip = get_ip();
   $date = TimeToDate(time());
   
   #-- if dobule news
   $this->db->query("select MAX(nid) from ".prefix."news where uid='{$_SESSION['mgc']['uid']}'");
   $this->db->next_record();
   $max = $this->db->Record['MAX(nid)'];
   $this->db->query("select * from ".prefix."news where nid='$max' and title='$post_title' and text='$post_text'");

   if($this->db->num_rows() == 0) {
     $this->db->query("insert into ".prefix."news set title='$post_title', text='$post_text', date='$date', uid='{$_SESSION['mgc']['uid']}', user='{$_SESSION['mgc']['user']}', posts='0', ip='$ip'");
   }

   $this->mod = '';

 } //end func
 
} //end class
?>
