<?php
/**
* inc.Statistics.php
* ------------------------------------------------------------
* Package:   MyGosuClan
* Version:   1.04
* License:   GNU GPL
* Author:    cagrET (Cezary Tomczak)
* Email:     cagret at gmail.com
* Homepage:  http://www.gosu.pl/mgc/
* ------------------------------------------------------------
*/

class statistics
{
  /* new object - configure */
  var $db;  //db class
  var $prefix;  //prefix in tables
  
  /* class vars */
  var $last24h_expire;  //last24h table
  var $online_expire;  //how old records in online table
  var $ip;
  
  /* return vars */
  var $visits;
  var $last24h;
  var $online;
  

  function statistics()
  {
  }
  
  function init()
  {
    $this->ip = get_ip();

    $this->set_visits() ? $this->set_last24h() : '';
    $this->clean_last24h();
    $this->set_online();  $this->clean_online();
    
    $this->count_visits();
    $this->count_last24h();
    $this->count_online();

  } //end func
  
  function get_visits()
  {
    return $this->visits;
  } //end func
  
  function get_last24h()
  {
    return $this->last24h;
  } //end func
  
  function get_online()
  {
    return $this->online;
  } //end func
  
  function count_visits()
  {
    $this->db->query("select * from `{$this->prefix}visits`");
    $this->db->next_record();
    $this->visits = $this->db->Record['visits'];
  } //end func
  
  function count_last24h()
  {
    $this->db->query("select COUNT(*) as count from  `{$this->prefix}last24h`");
    $this->db->next_record();
    $this->last24h = $this->db->Record['count'];
  } //end func
  
  function count_online()
  {
    $this->db->query("select * from `{$this->prefix}online` group by ip");
    $this->online = $this->db->num_rows();
  } //end func
  
  function set_visits()
  {
    $this->db->query("update `{$this->prefix}visits` set visits = IF(MD5(CONCAT(visits,'crc32'))=visits_coded, visits+1, 0),  visits_coded=MD5(CONCAT(visits,'crc32')), lip1=lip2, lip2=lip3, lip3='{$this->ip}' where lip1<>'{$this->ip}' and lip2<>'{$this->ip}' and lip3<>'{$this->ip}'");

    if($this->db->affected_rows() == 1) return true;
    return false;
    
  } //end func
  
  function set_last24h()
  {
    $referer = isset($_SERVER['HTTP_REFERER']) ? addslashes($_SERVER['HTTP_REFERER']) : '';
    if(stristr($referer, $_SERVER['HTTP_HOST']) !== false) $referer = '';
    $this->db->query("insert into `{$this->prefix}last24h` set time=unix_timestamp(), ip='{$this->ip}', referer='$referer'");
  } //end func
  
  function clean_last24h()
  {
    $expire = time() - $this->last24h_expire;
    $this->db->query("delete from `{$this->prefix}last24h` where time<'$expire'");
  } //end func
  
  function set_online()
  {
    $PHPSESSID = addslashes(session_id());
    $this->db->query("select * from `{$this->prefix}online` where PHPSESSID='$PHPSESSID'");

    #-- update time
    if($this->db->num_rows() == 1) {
      $this->db->query("update `{$this->prefix}online` set time=unix_timestamp() where PHPSESSID='$PHPSESSID'");
    }
    #-- insert new
    else {
      $this->db->query("insert into `{$this->prefix}online` set PHPSESSID='$PHPSESSID', time=unix_timestamp(), ip='{$this->ip}'");
    }
    
  } //end func
  
  function clean_online()
  {
    $expire = time() - $this->online_expire;
    $this->db->query("delete from `{$this->prefix}online` where time<'$expire'");
  } //end func
  
  function display_last24h()
  {
    $this->db->query("select * from `{$this->prefix}last24h` order by time desc");
    $last24h = array();
    while($this->db->next_record()) {
      $this->db->Record['host'] = @gethostbyaddr($this->db->Record['ip']);
      $last24h[] = $this->db->Record;
    }
    
    $this->smarty->assign_by_ref('last24h', $last24h);
    $this->smarty->display($this->dir.'last24h.tpl');
    
  } //end func

} //end class

?>
