<?php
/*
 * etphp/admin_classes/_users.class.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */

class _users {
 var $db;     //db class reference
 var $smarty; //smarty class reference

 var $uid; //user id
 var $mod; //mod
 
 var $tbl_users = array();
 var $tbl_access = array();
 var $error = array();
 
 var $show;

 function _users($db, $smarty, $show)
 {
   include 'init/lib/html.lib.php';
   include 'init/lib/validation.lib.php';

   $this->db = &$db;
   $this->smarty = &$smarty;
   $this->show = $show;

   $this->mod = get_param('mod');
   $this->uid = (int) get_param('uid');

   #-- mod
   if($this->mod == 'delete' && $this->uid) $this->mod_delete();
   elseif($this->mod == 'edit' && post_param('submit_users_edit') && $this->uid) $this->mod_edit();

   #-- get
   if($this->mod == 'edit' && $this->uid) $this->get_edit();
   elseif(!$this->mod) $this->get_list();
   
   #-- var
   $this->smarty->assign_by_ref('tbl_users', $this->tbl_users);
   $this->smarty->assign_by_ref('tbl_access', $this->tbl_users);
   $this->smarty->assign_by_ref('error', $this->error);

   #-- display
   if($this->mod == 'edit' && $this->uid) $this->smarty->display('admin/_users/edit.tpl');
   else $this->smarty->display('admin/_users/list.tpl');

 } //end func

 function get_list()
 {
   $page = (int) get_param('page');
   
   //count pages
   $limit = $this->show;

   $this->db->query("SELECT COUNT(*) as count FROM `".prefix."users`");
   $this->db->next_record();
   $pages = ceil($this->db->Record['count'] / $limit);
   
   if ($page < 1) $page = 1;
   if ($page > $pages) $page = $pages;
   
   $offset = $page * $limit - $limit;
   
   $this->smarty->assign('page', $page);
   $this->smarty->assign('pages', $pages);

   $this->db->query("SELECT uid,user,auth,ip FROM ".prefix."users ORDER BY uid LIMIT $offset,$limit");
   while($this->db->next_record()) {
     $this->tbl_users[] = $this->db->Record;
   }
   
 } //end func

 function get_edit()
 {
   $this->db->query("select * from ".prefix."users where uid='{$this->uid}'");
   $this->db->next_record();
   $this->tbl_users = $this->db->Record;
   
   $this->tbl_users['access'] = $GLOBALS['r']->return_access($this->db->Record['rights']);
 } //end func

 function mod_edit()
 {
   #-- if user which edits have auth > of the edited user
   $this->db->query("select * from ".prefix."users where uid='{$this->uid}'");
   $this->db->next_record();
   if($this->db->Record['auth'] > $_SESSION['mgc']['auth']) $this->error['auth'] = 1;

   $post_user    = check_html(post_param('user'));
   $post_pass    = trim(post_param('pass'));
   $post_email   = check_html(post_param('email'));
   $post_auth    = (int) post_param('auth');
   $post_rights  = (int) array_sum((array) post_param('rights'));
   $post_active  = (int) post_param('active');
   $post_icq     = check_html(post_param('icq'));
   $post_gg      = check_html(post_param('gg'));
   $post_website = check_html(post_param('website'));
   $post_scnick  = check_html(post_param('scnick'));
   
   $coded_pass = coded_pass($post_pass);
   
   #-- if errors
   if(!$post_user)  $this->error['user'] = 1;
   if(!$post_email || !is_email($post_email)) $this->error['email'] = 1;
   if(!in_array($post_auth, $GLOBALS['auth'])) $this->error['auth'] = 1;
   if($post_auth > $_SESSION['mgc']['auth']) $this->error['auth'] = 1;
   
   #-- if user with that nick already exists
   $this->db->query("select * from ".prefix."users where uid<>'{$this->uid}' and user='$post_user'");
   if($this->db->num_rows() != 0) $this->error['user_exists'] = 1;
   
   if($this->error) return 0;
   
   $query = "update ".prefix."users set user='$post_user', ";
   if($post_pass) $query .= "pass='$coded_pass', ";
   $query .= "email='$post_email', auth='$post_auth', rights='$post_rights', active='$post_active', icq='$post_icq', gg='$post_gg', website='$post_website', scnick='$post_scnick' where uid='{$this->uid}'";
   $this->db->query($query);
   $this->mod = '';

 } //end func

 function mod_delete()
 {
   $this->db->query("select * from ".prefix."users where uid='{$this->uid}'");
   $this->db->next_record();
   $this->mod = '';
      
   if($this->db->Record['auth'] > $_SESSION['mgc']['auth']) return 0;
   
   $this->db->query("delete from ".prefix."users where uid='{$this->uid}'");

   
 } //end func

} //end class
?>
